/* tslint:disable */
/* eslint-disable */
/**
 * Ampli - A strong typed wrapper for your Analytics
 *
 * This file is generated by Amplitude.
 * To update run 'ampli pull frontend'
 *
 * Required dependencies: @amplitude/analytics-browser@^1.3.0
 * Tracking Plan Version: 2
 * Build: 1.0.0
 * Runtime: browser:javascript-ampli-v2
 *
 * [View Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest)
 *
 * [Full Setup Instructions](https://data.amplitude.com/gravity-demo/Gravity%20Planka/implementation/frontend)
 */

import * as amplitude from '@amplitude/analytics-browser';

/**
 * @typedef BaseEvent
 * @type {object}
 * @property {string} event_type
 * @property {Object.<string, *>} [event_properties]
 */

/**
 * @typedef Plan
 * @type {object}
 * @property {string} [branch]
 * @property {string} [source]
 * @property {string} [version]
 * @property {string} [versionId]
 */

/**
 * @typedef LoadClientOptions
 * @type {object}
 * @property {string} [apiKey]
 * @property {Object} [configuration]
 * @property {BrowserClient} [instance]
 */

/**
 * @typedef LoadOptions
 * @type {object}
 * @property {'default'} [environment]
 * @property {boolean} [disabled]
 * @property {LoadClientOptions} [client]
 */

/**
 * @typedef {Object} EventOptions
 * @type {object}
 */

/**
 * @typedef ApiKey
 * @type {object}
 * @property {string} default
 */
export const ApiKey = {
  default: '94c2c58cc87948652ca627141c28261d'
};

/**
 * Default Amplitude configuration options. Contains tracking plan information.
 */
export const DefaultConfiguration = {
  plan: {
    version: '2',
    branch: 'main',
    source: 'frontend',
    versionId: '3e1270c0-30fa-4ab1-a785-6a6ce943c1bd'
  },
  ...{
    ingestionMetadata: {
      sourceName: 'browser-javascript-ampli',
      sourceVersion: '2.0.0'
    }
  }
};

export class AddedLabelToCard {
  constructor() {
    this.event_type = 'Added label to card';
  }
}

export class AddedMemberToCard {
  constructor() {
    this.event_type = 'Added member to card';
  }
}

export class CommentedCard {
  constructor() {
    this.event_type = 'Commented card';
  }
}

export class CreatedBoard {
  constructor() {
    this.event_type = 'Created board';
  }
}

export class CreatedCard {
  constructor() {
    this.event_type = 'Created card';
  }
}

export class CreatedList {
  constructor() {
    this.event_type = 'Created list';
  }
}

export class CreatedProject {
  constructor() {
    this.event_type = 'Created project';
  }
}

export class MovedACard {
  constructor() {
    this.event_type = 'Moved a card';
  }
}

export class RemovedBoard {
  constructor() {
    this.event_type = 'Removed board';
  }
}

export class RemovedCard {
  constructor() {
    this.event_type = 'Removed card';
  }
}

export class RemovedCommentFromCard {
  constructor() {
    this.event_type = 'Removed comment from card';
  }
}

export class RemovedLabelFromCard {
  constructor() {
    this.event_type = 'Removed label from card';
  }
}

export class RemovedList {
  constructor() {
    this.event_type = 'Removed list';
  }
}

export class RemovedMemberFromCard {
  constructor() {
    this.event_type = 'Removed member from card';
  }
}

export class RemovedProject {
  constructor() {
    this.event_type = 'Removed project';
  }
}

/**
 * @typedef PromiseResult
 * @type {object}
 * @property {Promise|undefined} promise
 */

const getVoidPromiseResult = () => ({ promise: Promise.resolve() });

// prettier-ignore
export class Ampli {
  constructor() {
    /* @type {BrowserClient|undefined} */
    this.amplitude = undefined;
    this.disabled = false;
  }

  /**
   * @return {BrowserClient}
   */
  get client() {
    this.isInitializedAndEnabled();
    return this.amplitude;
  }

  /**
   * @return {boolean}
   */
  get isLoaded() {
    return this.amplitude != null;
  }

  /**
   * @private
   * @return {boolean}
   */
  isInitializedAndEnabled() {
    if (!this.isLoaded) {
      console.error('ERROR: Ampli is not yet initialized. Have you called ampli.load() on app start?');
      return false;
    }
    return !this.disabled;
  }

  /**
   * Initialize the Ampli SDK. Call once when your application starts.
   *
   * @param {LoadOptions} options Configuration options to initialize the Ampli SDK with. 'environment', 'client.apiKey' or 'client.instance' is required.
   *
   * @return {PromiseResult}
   */
  load(options) {
    this.disabled = options?.disabled ?? false;

    if (this.isLoaded) {
      console.warn('WARNING: Ampli is already initialized. Ampli.load() should be called once at application startup.');
      return getVoidPromiseResult();
    }

    let apiKey;
    if (options?.client?.apiKey) {
      apiKey = options.client.apiKey;
    } else if (options?.environment) {
      apiKey = ApiKey[options.environment];
    }

    if (options?.client?.instance) {
      this.amplitude = options?.client?.instance;
    } else if (apiKey) {
      this.amplitude = amplitude.createInstance();
      return this.amplitude.init(apiKey, undefined, { ...DefaultConfiguration, ...options?.client?.configuration });
    } else {
      console.error("ERROR: ampli.load() requires 'environment', 'client.apiKey', or 'client.instance'");
    }

    return getVoidPromiseResult();
  }

  /**
   * Identify a user.
   *
   * @param {string|undefined} userId The user's id.
   * @param {EventOptions} [options] Optional event options.
   *
   * @return {PromiseResult}
   */
  identify(userId, options) {
    if (!this.isInitializedAndEnabled()) {
      return getVoidPromiseResult();
    }

    if (userId) {
      options = {...options, user_id: userId};
    }

    const ampIdentify = new amplitude.Identify();
    return this.amplitude.identify(ampIdentify, options);
  }

  /**
   * Track event
   *
   * @param {BaseEvent} event The event to track.
   * @param {EventOptions} [options] Optional event options.
   *
   * @return {PromiseResult}
   */
  track(event, options) {
    if (!this.isInitializedAndEnabled()) {
      return getVoidPromiseResult();
    }

    return this.amplitude.track(event, undefined, options);
  }

  /**
   * Added label to card
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Added%20label%20to%20card)
   *
   * Owner: Julien Botella
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  addedLabelToCard(options) {
    return this.track(new AddedLabelToCard(), options);
  }

  /**
   * Added member to card
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Added%20member%20to%20card)
   *
   * Owner: Joan RACENET
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  addedMemberToCard(options) {
    return this.track(new AddedMemberToCard(), options);
  }

  /**
   * Commented card
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Commented%20card)
   *
   * Owner: Joan RACENET
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  commentedCard(options) {
    return this.track(new CommentedCard(), options);
  }

  /**
   * Created board
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Created%20board)
   *
   * Owner: Julien Botella
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  createdBoard(options) {
    return this.track(new CreatedBoard(), options);
  }

  /**
   * Created card
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Created%20card)
   *
   * Owner: Joan RACENET
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  createdCard(options) {
    return this.track(new CreatedCard(), options);
  }

  /**
   * Created list
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Created%20list)
   *
   * Owner: Julien Botella
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  createdList(options) {
    return this.track(new CreatedList(), options);
  }

  /**
   * Created project
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Created%20project)
   *
   * Owner: Julien Botella
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  createdProject(options) {
    return this.track(new CreatedProject(), options);
  }

  /**
   * Moved a card
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Moved%20a%20card)
   *
   * Owner: Joan RACENET
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  movedACard(options) {
    return this.track(new MovedACard(), options);
  }

  /**
   * Removed board
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Removed%20board)
   *
   * Owner: Julien Botella
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  removedBoard(options) {
    return this.track(new RemovedBoard(), options);
  }

  /**
   * Removed card
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Removed%20card)
   *
   * Owner: Julien Botella
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  removedCard(options) {
    return this.track(new RemovedCard(), options);
  }

  /**
   * Removed comment from card
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Removed%20comment%20from%20card)
   *
   * Owner: Julien Botella
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  removedCommentFromCard(options) {
    return this.track(new RemovedCommentFromCard(), options);
  }

  /**
   * Removed label from card
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Removed%20label%20from%20card)
   *
   * Owner: Julien Botella
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  removedLabelFromCard(options) {
    return this.track(new RemovedLabelFromCard(), options);
  }

  /**
   * Removed list
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Removed%20list)
   *
   * Owner: Julien Botella
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  removedList(options) {
    return this.track(new RemovedList(), options);
  }

  /**
   * Removed member from card
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Removed%20member%20from%20card)
   *
   * Owner: Julien Botella
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  removedMemberFromCard(options) {
    return this.track(new RemovedMemberFromCard(), options);
  }

  /**
   * Removed project
   *
   * [View in Tracking Plan](https://data.amplitude.com/gravity-demo/Gravity%20Planka/events/main/latest/Removed%20project)
   *
   * Owner: Julien Botella
   *
   * @param {EventOptions} [options] Options for this track call.
   */
  removedProject(options) {
    return this.track(new RemovedProject(), options);
  }
}

export const ampli = new Ampli();
